unit unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, ComCtrls, StdCtrls, dglOpenGL,windows;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Timer1: TTimer;
    ToolBar1: TToolBar;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    mpos:record
      a, b, c, x, y, z: single;
    end;
    Schritt: integer;
    procedure Disk(ri, ra: single);
    procedure IinitDLG_OpenGL;
    procedure BuildFont;
    procedure glPrint(fontx,textx:string);
    Procedure Zuruecksetzen(left_,top_,Width_,Height_:word);
  public
  end;

var
  Form1: TForm1;
  GraphicDevice: HDC;
  RenderingContext: HGLRC;
  DC:HDC;
  RC:HGLRC;
  OGLFont: Cardinal; //Variable für den TextFont
  // Die Adressen der benutzten Fonts
  Symbol,
  microsoft_sans_serif,
  Times_New_Roman:tglint;

  // Lichtposition
  glfLight0Position: Array[0..3] of TGLfloat = (200,200,100,1);
  glfLight0Direction: Array[0..3] of TGLfloat = (-20,-20,-100,1);
  gldAspect : TGLfloat;
  // Lichteinstellungen
  glfLightAmbient  : Array[0..3] of TGLfloat = (0.8,0.8,0.8,1);
  glfLightDiffuse  : Array[0..3] of TGLfloat = (1,1,1,1);
  glfLightSpecular : Array[0..3] of TGLfloat = (0.4,0.4,0.4,1);
  // Materialeinstellungen
  glfMatrialAmbient : Array[0..3] of TGLfloat = (0.8, 0.8, 0.8, 1.0);
  glfMatrialDiffuse : Array[0..3] of TGLfloat = (0.8, 0.8, 0.8, 1.0);
  glfMatrialSpecular: Array[0..3] of TGLfloat = (1.0, 1.0, 1.0, 1.0);
  glfMatrialShine:  TGLfloat = 110;
  glfLightModelAmbient: Array[0..3] of TGLfloat =(0.2,0.2,0.2,1.0);

const Perspective_winkel=20;

implementation

{ TForm1 }

const
  FSektoren = 6;
  maxSchritt = 500;

(*********** OpenGl ******************)
(* Materialeigenschaften einstellen  *)
(*************************************)
procedure InitializeMaterial;
begin
  glMaterialfv(GL_FRONT_and_back, GL_AMBIENT,   @glfMatrialAmbient);
  glMaterialfv(GL_FRONT_and_back, GL_DIFFUSE,   @glfMatrialDiffuse);
  glMaterialfv(GL_FRONT_and_back, GL_SPECULAR,  @glfMatrialSpecular);
  glMaterialf (GL_FRONT_and_back, GL_SHININESS, glfMatrialShine);
end;

(*********** OpenGl *******************)
(* Lichteigenschaften einstellen      *)
(* es wird nur ein Licht Nr.0 benutzt *)
(**************************************)
procedure InitializeLight;
begin
 glMatrixMode(GL_MODELVIEW);
 glLoadIdentity;
 glEnable(GL_LIGHT0);
 glLightfv(GL_LIGHT0, GL_POSITION ,@glfLight0Position);
 glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, @glfLight0Direction);
 glLightfv(GL_LIGHT0, GL_AMBIENT,  @glfLightAmbient);
 glLightfv(GL_LIGHT0, GL_DIFFUSE,  @glfLightDiffuse);
 glLightfv(GL_LIGHT0, GL_SPECULAR, @glfLightSpecular);
end;


(******************************************)
(* Displaylisten für die Font's erstellen *)
(******************************************)
procedure tform1.BuildFont;
var font1: HFONT;         // Windows Font ID
begin
 Symbol:= glGenLists(256);
 microsoft_sans_serif:= glGenLists(256);
 Times_New_Roman:= glGenLists(256);

 // mircosoft_sans_serif-Font erzeugen
 font1:= CreateFont
 (0,   // Height Of Font
  0,    // Width Of Font
  0,    // Angle Of Escapement
  0,    // Orientation Angle
  0,    // Schrift Fett? Nein!
  0,    // Schrift Kursiv? Nein!
  0,    // Auch nicht unterstrichen….
  0,    // … oder gar durchgestrichen
  ANSI_CHARSET,        // Character Set Identifier
  OUT_TT_PRECIS,       // Output Precision
  CLIP_DEFAULT_PRECIS, // Clipping Precision
  ANTIALIASED_QUALITY, // Output Quality
  FF_DONTCARE or DEFAULT_PITCH,   // Family And Pitch
  'microsoft sans serif');    // Font Name

  SelectObject(dc,font1); // Die Schriftart Wählen

  wglUseFontOutlines( dc, // Der Aktuelle DC
  0,                 // Der erste “Buchstabe”
  255,               // Die gesamte Anzahl der Buchstaben
  microsoft_sans_serif,      // Die Displayliste
  0.0,               // Deviation From The True Outlines
  0.5,               // Die “Dicke” der Schrift in Z-Richtung
  WGL_FONT_POLYGONS, // Wir wollen ganze Polygone, keine Linien
  nil);             // Unserer Puffer

 // Symbol-Font erzeugen
 font1:= CreateFont
 (0,   // Height Of Font
  0,    // Width Of Font
  0,    // Angle Of Escapement
  0,    // Orientation Angle
  0,    // Schrift Fett? Nein!
  0,    // Schrift Kursiv? Nein!
  0,    // Auch nicht unterstrichen….
  0,    // … oder gar durchgestrichen
  ANSI_CHARSET,        // Character Set Identifier
  OUT_TT_PRECIS,       // Output Precision
  CLIP_DEFAULT_PRECIS, // Clipping Precision
  ANTIALIASED_QUALITY, // Output Quality
  FF_DONTCARE or DEFAULT_PITCH,   // Family And Pitch
  'Symbol');                 // Font Name

  SelectObject(dc,font1); // Die Schriftart Wählen

  wglUseFontOutlines( dc, // Der Aktuelle DC
  0,                 // Der erste “Buchstabe”
  255,               // Die gesamte Anzahl der Buchstaben
  Symbol,      // Die Displayliste
  0.0,               // Deviation From The True Outlines
  0.1,               // Die “Dicke” der Schrift in Z-Richtung
  WGL_FONT_POLYGONS, // Wir wollen ganze Polygone, keine Linien
  nil);             // Unserer Puffer

  // Times-New_Ronman-Font erzeugen
  font1:= CreateFont
  (0,   // Height Of Font
  0,    // Width Of Font
  0,    // Angle Of Escapement
  0,    // Orientation Angle
  0,    // Schrift Fett? Nein!
  0,    // Schrift Kursiv? Nein!
  0,    // Auch nicht unterstrichen….
  0,    // … oder gar durchgestrichen
  ANSI_CHARSET,        // Character Set Identifier
  OUT_TT_PRECIS,       // Output Precision
  CLIP_DEFAULT_PRECIS, // Clipping Precision
  ANTIALIASED_QUALITY, // Output Quality
  FF_DONTCARE or DEFAULT_PITCH,   // Family And Pitch
  'Times New Roman');                 // Font Name

  SelectObject(dc,font1); // Die Schriftart Wählen

  wglUseFontOutlines( dc, // Der Aktuelle DC
  0,                 // Der erste “Buchstabe”
  255,               // Die gesamte Anzahl der Buchstaben
  Times_New_Roman,      // Die Displayliste
  0.0,               // Deviation From The True Outlines
  0.1,               // Die “Dicke” der Schrift in Z-Richtung
  WGL_FONT_POLYGONS, // Wir wollen ganze Polygone, keine Linien
  nil);             // Unserer Puffer

  end;

procedure TForm1.Disk(ri, ra: single);
var
  w, seg: single;
  i: integer;
begin
  glbegin(GL_TRIANGLE_STRIP);
  seg := 360 / FSektoren;
  for i := 0 to FSektoren do begin
    w := i * seg / 180 * Pi;
    glColor3f(1, 0, 0);
    glVertex3f(cos(w) * ri, sin(w) * ri, 0);
    glColor3f(0, 1, 0);
    glVertex3f(cos(w) * ra, sin(w) * ra, 0);
  end;
  glEnd();
end;

(*****************)
(* Text ausgeben *)
(*****************)
procedure tform1.glPrint(fontx,textx:string);
begin
 // Wenn kein Text vorhanden ist
 if (fontx='') or (textx = '') then Exit;
 // Alle Display-List-Bits retten
 glPushAttrib (GL_ALL_ATTRIB_BITS);
 // Die Startadresse des passenden Fonts wählen
 if uppercase(fontx)='SYMBOL' then glListBase(Symbol)
 else
 if uppercase(fontx)='TIMES_NEW_ROMAN' then glListBase(Times_New_Roman)
 else
 if uppercase(fontx)='MICROSOFT_SANS_SERIF' then glListBase(microsoft_sans_serif)
 else
  begin
   // Die Display-List-Bits vom Stak holen
   glPopAttrib();
   exit;
  end;
 // Den Text ausgeben
 glCallLists(length(textx),GL_UNSIGNED_BYTE,pointer(textx));
 // Die Display-List-Bits vom Stak holen
 glPopAttrib();
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Zuruecksetzen(0,0,Width,Height);

  glClearColor(0.8, 0.5, 0.3, 1.0);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glEnable(GL_DEPTH_TEST);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  with mpos do begin
    glTranslatef(x, y, z-6);
    glRotatef(a, 1, 0, 0);
    glRotatef(b, 0, 1, 0);
    glRotatef(c, 0, 0, 1);
    Disk(0.5, 0.8);

    x := x / maxSchritt * Schritt;
    y := y / maxSchritt * Schritt;
    z := z / maxSchritt * Schritt;
    a := a / maxSchritt * Schritt;
    b := b / maxSchritt * Schritt;
    c := c / maxSchritt * Schritt;
    if Schritt > 0 then begin
      Dec(Schritt,2);
    end;
  end;

 // Textausgabe

 // Text ein wenig in die Mitte und vor die Disk verschieben
 glTranslatef(mpos.x-1.0,-0.08,+0.5);

 // Farbe des Textes
 glcolor3f(0.35,0.3,0.15);

 // die Größe des Textes festlegen
 glScalef(0.5,
          0.5,
          0.8);

 // Text ausgeben
 // einen der geladenen Fonts benutzen 'SYMBOL' oder
 //  'times_new_roman' oder
 // 'microsoft_sans_serif' benutzen
 // glprint('times_new_roman','Hallo Otto');
 //glprint('symbol','Hallo Otto');
 glprint('microsoft_sans_serif','Hallo Otto');

 // Zeichnung an DC übergeben
 SwapBuffers(DC);
end;

// OpenGL initialisieren
procedure tform1.IinitDLG_OpenGL;
begin
 InitOpenGL;
 // Das Panel1 als Ausgabefenster
 DC :=GetDC(form1.handle);
 RC :=CreateRenderingContext(DC,[opDoubleBuffered],32,24,0,0,0,0);
 // Bindet die OpenGl-Szene RC an die Grafikfläche DC
 ActivateRenderingContext(DC, RC);

 // Tiefentest aktivieren
 glEnable(GL_DEPTH_TEST);
 // verhindert ein durchschimmern verdeckter Flächen
 glEnable(GL_POLYGON_OFFSET_FILL);
 glPolygonOffset(0.5, 1.0);

 // Lichtmodus einschalten
 glEnable(GL_LIGHTING);
 // Material-Farben-modus einschalten
 glEnable(GL_COLOR_MATERIAL);
 glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, 0);
 // Licht soll auf beiden Seiten einer Fläche wirksam sein
 glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, 1);
 // Lichtmodell aktivieren
 glLightModelfv(GL_LIGHT_MODEL_AMBIENT, @glfLightModelAmbient);
 // Licht 0 einstellen und positionieren
 InitializeLight;
 // Material-Eigenschalten einstellen
 InitializeMaterial;

end;


(*********** OpenGl *******************)
(* Die ganze OpenglScene zurücksetzen *)
(**************************************)
Procedure tform1.Zuruecksetzen(left_,top_,Width_,Height_:word);
begin
  // Raum_Modus
  glMatrixMode(GL_PROJECTION);
  // alles in den Ausgangszustand versetzen
  glLoadIdentity;
  // Breite und Höhe des Ausgabefensters
  gldAspect := Width_ / Height_;
  gluPerspective(Perspective_winkel,
                 gldAspect,
                 0.001,     // Nächster Punkt für clipping plane
                 32768.0);  // Entferntester Punkt für clipping plane
  glViewport(left_,top_,Width_,Height_);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
 self.DoubleBuffered:=true;
 IinitDLG_OpenGL;
 BuildFont;
 Schritt := 0;
 Randomize;
end;


procedure TForm1.Button1Click(Sender: TObject);

  function r(w: single): single;
  begin
    Result := Random * w - w / 2;
  end;

const
  rxyz = 2.5;
  rabc = 360;
begin
  with mpos do begin
    x := r(rxyz);
    y := r(rxyz);
    z := r(rxyz);
    a := r(rabc);
    b := r(rabc);
    c := r(rabc);
  end;
  Schritt := maxSchritt;

end;


initialization

  {$I unit1.lrs}

end.
